For the complete documentation index, see llms.txt. This page is also available as Markdown.

Recommendations

Recommendations for workloads and node pools.

Returns Applied Recommendations statistics grouped by Resource type with total savings

post

Returns the Applied Recommendations statistics grouped by resource type with total savings.

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

Body

Properties of the CCMRecommendation Filter defined in Harness

minSavingnumber · doubleOptional

Fetch recommendations with Saving more than minSaving

minCostnumber · doubleOptional

Fetch recommendations with Cost more than minCost

daysBackinteger · int64Optional

Fetch recommendations generated in last daysBack days

offsetinteger · int64Optional

Query Offset

limitinteger · int64Optional

Query Limit

sortBystring · enumOptional

Field to sort recommendations by. Allowed values: MONTHLY_SAVING, MONTHLY_COST, APPLIED_AT, RESOURCE_TYPE

Possible values:
sortOrderstring · enumOptional

Sort order for recommendations. Allowed values: ASCENDING, DESCENDING. Defaults to DESCENDING

Possible values:
childRecommendationbooleanOptional

toggle childRecommendation value

includeIgnoredRecommendationbooleanOptional

toggle includeIgnoredRecommendation value

parentRecommendationbooleanOptional

toggle parentRecommendation value

filterTypestring · enumOptionalPossible values:
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendation/overview/stats/applied
POST /gateway/ccm/api/recommendation/overview/stats/applied?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 1947

{
  "k8sRecommendationFilterPropertiesDTO": {
    "ids": [
      "text"
    ],
    "names": [
      "text"
    ],
    "namespaces": [
      "text"
    ],
    "clusterNames": [
      "text"
    ],
    "resourceTypes": [
      "WORKLOAD"
    ],
    "recommendationStates": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "regions": [
      "text"
    ]
  },
  "awsRecommendationFilterPropertiesDTO": {
    "instanceType": [
      "text"
    ]
  },
  "azureRecommendationFilterProperties": {
    "instanceType": [
      "text"
    ],
    "resourceGroup": [
      "text"
    ]
  },
  "containerRecommendationFilterPropertiesDTO": {
    "k8sClusterName": [
      "text"
    ],
    "k8sNamespace": [
      "text"
    ],
    "ecsClusterName": [
      "text"
    ],
    "ecsLaunchType": [
      "text"
    ]
  },
  "governanceRecommendationFilterPropertiesDTO": {
    "governanceRuleName": [
      "text"
    ]
  },
  "baseRecommendationFilterPropertiesDTO": {
    "id": [
      "text"
    ],
    "cloudAccountId": [
      "text"
    ],
    "cloudAccountName": [
      "text"
    ],
    "resourceId": [
      "text"
    ],
    "resourceName": [
      "text"
    ],
    "region": [
      "text"
    ],
    "resourceType": [
      "WORKLOAD"
    ],
    "recommendationState": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "appliedAtStartTime": 1,
    "appliedAtEndTime": 1,
    "appliedByUserName": [
      "text"
    ],
    "verificationStatus": [
      "text"
    ],
    "perspectiveId": [
      "text"
    ]
  },
  "perspectiveFilters": [
    {
      "idFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "NOT_IN",
        "values": [
          "text"
        ]
      },
      "timeFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "AFTER",
        "value": 1
      },
      "timeRangeTypeFilter": "LAST_MONTH",
      "viewMetadataFilter": {
        "viewId": "text",
        "isPreview": true,
        "preview": true
      },
      "ruleFilter": {
        "conditions": [
          {
            "field": {
              "fieldId": "text",
              "fieldName": "text",
              "identifier": "CLUSTER",
              "identifierName": "text"
            },
            "operator": "NOT_IN",
            "values": [
              "text"
            ]
          }
        ]
      }
    }
  ],
  "minSaving": 1,
  "minCost": 1,
  "daysBack": 1,
  "offset": 1,
  "limit": 1,
  "sortBy": "MONTHLY_SAVING",
  "sortOrder": "ASCENDING",
  "childRecommendation": true,
  "includeIgnoredRecommendation": true,
  "parentRecommendation": true,
  "tagDTOs": [
    {
      "key": "text",
      "value": "text"
    }
  ],
  "costCategoryDTOs": [
    {
      "costCategory": "text",
      "costBucket": "text"
    }
  ],
  "tags": {
    "ANY_ADDITIONAL_PROPERTY": "text"
  },
  "filterType": "CCMRecommendation"
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return void

post

Mark recommendation as inferred verified/rejected

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

Body
recommendationIdstringRequired
verificationStatusstring · enumRequiredPossible values:
commentstring · min: 1 · max: 100Optional
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendation/overview/change-inference-status
POST /gateway/ccm/api/recommendation/overview/change-inference-status?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 91

{
  "recommendationId": "text",
  "verificationStatus": "INFERRED_PENDING_REVIEW",
  "comment": "text"
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return void

post

Mark recommendation as applied/open

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

recommendationIdstringRequired
statestring · enumRequiredPossible values:
Body
appliedSavingsnumber · doubleOptional
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendation/overview/change-state
POST /gateway/ccm/api/recommendation/overview/change-state?accountIdentifier=text&recommendationId=text&state=OPEN HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 20

{
  "appliedSavings": 1
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return the number of Recommendations

post

Returns the total number of Recommendations based on the specified filters.

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

Body

Properties of the CCMRecommendation Filter defined in Harness

minSavingnumber · doubleOptional

Fetch recommendations with Saving more than minSaving

minCostnumber · doubleOptional

Fetch recommendations with Cost more than minCost

daysBackinteger · int64Optional

Fetch recommendations generated in last daysBack days

offsetinteger · int64Optional

Query Offset

limitinteger · int64Optional

Query Limit

sortBystring · enumOptional

Field to sort recommendations by. Allowed values: MONTHLY_SAVING, MONTHLY_COST, APPLIED_AT, RESOURCE_TYPE

Possible values:
sortOrderstring · enumOptional

Sort order for recommendations. Allowed values: ASCENDING, DESCENDING. Defaults to DESCENDING

Possible values:
childRecommendationbooleanOptional

toggle childRecommendation value

includeIgnoredRecommendationbooleanOptional

toggle includeIgnoredRecommendation value

parentRecommendationbooleanOptional

toggle parentRecommendation value

filterTypestring · enumOptionalPossible values:
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendation/overview/count
POST /gateway/ccm/api/recommendation/overview/count?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 1947

{
  "k8sRecommendationFilterPropertiesDTO": {
    "ids": [
      "text"
    ],
    "names": [
      "text"
    ],
    "namespaces": [
      "text"
    ],
    "clusterNames": [
      "text"
    ],
    "resourceTypes": [
      "WORKLOAD"
    ],
    "recommendationStates": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "regions": [
      "text"
    ]
  },
  "awsRecommendationFilterPropertiesDTO": {
    "instanceType": [
      "text"
    ]
  },
  "azureRecommendationFilterProperties": {
    "instanceType": [
      "text"
    ],
    "resourceGroup": [
      "text"
    ]
  },
  "containerRecommendationFilterPropertiesDTO": {
    "k8sClusterName": [
      "text"
    ],
    "k8sNamespace": [
      "text"
    ],
    "ecsClusterName": [
      "text"
    ],
    "ecsLaunchType": [
      "text"
    ]
  },
  "governanceRecommendationFilterPropertiesDTO": {
    "governanceRuleName": [
      "text"
    ]
  },
  "baseRecommendationFilterPropertiesDTO": {
    "id": [
      "text"
    ],
    "cloudAccountId": [
      "text"
    ],
    "cloudAccountName": [
      "text"
    ],
    "resourceId": [
      "text"
    ],
    "resourceName": [
      "text"
    ],
    "region": [
      "text"
    ],
    "resourceType": [
      "WORKLOAD"
    ],
    "recommendationState": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "appliedAtStartTime": 1,
    "appliedAtEndTime": 1,
    "appliedByUserName": [
      "text"
    ],
    "verificationStatus": [
      "text"
    ],
    "perspectiveId": [
      "text"
    ]
  },
  "perspectiveFilters": [
    {
      "idFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "NOT_IN",
        "values": [
          "text"
        ]
      },
      "timeFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "AFTER",
        "value": 1
      },
      "timeRangeTypeFilter": "LAST_MONTH",
      "viewMetadataFilter": {
        "viewId": "text",
        "isPreview": true,
        "preview": true
      },
      "ruleFilter": {
        "conditions": [
          {
            "field": {
              "fieldId": "text",
              "fieldName": "text",
              "identifier": "CLUSTER",
              "identifierName": "text"
            },
            "operator": "NOT_IN",
            "values": [
              "text"
            ]
          }
        ]
      }
    }
  ],
  "minSaving": 1,
  "minCost": 1,
  "daysBack": 1,
  "offset": 1,
  "limit": 1,
  "sortBy": "MONTHLY_SAVING",
  "sortOrder": "ASCENDING",
  "childRecommendation": true,
  "includeIgnoredRecommendation": true,
  "parentRecommendation": true,
  "tagDTOs": [
    {
      "key": "text",
      "value": "text"
    }
  ],
  "costCategoryDTOs": [
    {
      "costCategory": "text",
      "costBucket": "text"
    }
  ],
  "tags": {
    "ANY_ADDITIONAL_PROPERTY": "text"
  },
  "filterType": "CCMRecommendation"
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return the list of filter values for the Recommendations

post

Returns the list of filter values for all the specified filters.

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

Body

The applicable 'columns' values are 'name', 'resourceType', 'namespace', 'clusterName'

columnsstring[]Optional
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendation/overview/filter-values
POST /gateway/ccm/api/recommendation/overview/filter-values?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 1977

{
  "columns": [
    "text"
  ],
  "filter": {
    "k8sRecommendationFilterPropertiesDTO": {
      "ids": [
        "text"
      ],
      "names": [
        "text"
      ],
      "namespaces": [
        "text"
      ],
      "clusterNames": [
        "text"
      ],
      "resourceTypes": [
        "WORKLOAD"
      ],
      "recommendationStates": [
        "OPEN"
      ],
      "cloudProvider": [
        "AWS"
      ],
      "regions": [
        "text"
      ]
    },
    "awsRecommendationFilterPropertiesDTO": {
      "instanceType": [
        "text"
      ]
    },
    "azureRecommendationFilterProperties": {
      "instanceType": [
        "text"
      ],
      "resourceGroup": [
        "text"
      ]
    },
    "containerRecommendationFilterPropertiesDTO": {
      "k8sClusterName": [
        "text"
      ],
      "k8sNamespace": [
        "text"
      ],
      "ecsClusterName": [
        "text"
      ],
      "ecsLaunchType": [
        "text"
      ]
    },
    "governanceRecommendationFilterPropertiesDTO": {
      "governanceRuleName": [
        "text"
      ]
    },
    "baseRecommendationFilterPropertiesDTO": {
      "id": [
        "text"
      ],
      "cloudAccountId": [
        "text"
      ],
      "cloudAccountName": [
        "text"
      ],
      "resourceId": [
        "text"
      ],
      "resourceName": [
        "text"
      ],
      "region": [
        "text"
      ],
      "resourceType": [
        "WORKLOAD"
      ],
      "recommendationState": [
        "OPEN"
      ],
      "cloudProvider": [
        "AWS"
      ],
      "appliedAtStartTime": 1,
      "appliedAtEndTime": 1,
      "appliedByUserName": [
        "text"
      ],
      "verificationStatus": [
        "text"
      ],
      "perspectiveId": [
        "text"
      ]
    },
    "perspectiveFilters": [
      {
        "idFilter": {
          "field": {
            "fieldId": "text",
            "fieldName": "text",
            "identifier": "CLUSTER",
            "identifierName": "text"
          },
          "operator": "NOT_IN",
          "values": [
            "text"
          ]
        },
        "timeFilter": {
          "field": {
            "fieldId": "text",
            "fieldName": "text",
            "identifier": "CLUSTER",
            "identifierName": "text"
          },
          "operator": "AFTER",
          "value": 1
        },
        "timeRangeTypeFilter": "LAST_MONTH",
        "viewMetadataFilter": {
          "viewId": "text",
          "isPreview": true,
          "preview": true
        },
        "ruleFilter": {
          "conditions": [
            {
              "field": {
                "fieldId": "text",
                "fieldName": "text",
                "identifier": "CLUSTER",
                "identifierName": "text"
              },
              "operator": "NOT_IN",
              "values": [
                "text"
              ]
            }
          ]
        }
      }
    ],
    "minSaving": 1,
    "minCost": 1,
    "daysBack": 1,
    "offset": 1,
    "limit": 1,
    "sortBy": "MONTHLY_SAVING",
    "sortOrder": "ASCENDING",
    "childRecommendation": true,
    "includeIgnoredRecommendation": true,
    "parentRecommendation": true,
    "tagDTOs": [
      {
        "key": "text",
        "value": "text"
      }
    ],
    "costCategoryDTOs": [
      {
        "costCategory": "text",
        "costBucket": "text"
      }
    ],
    "tags": {
      "ANY_ADDITIONAL_PROPERTY": "text"
    },
    "filterType": "CCMRecommendation"
  }
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return list of supported recommendation filters

get

Returns the list of supported filter field IDs for recommendations.

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
get/recommendation/overview/supported-filters
GET /gateway/ccm/api/recommendation/overview/supported-filters?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Accept: */*
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return Recommendations for IaCM Resources

post

Returns complete Recommendations for IaCM-managed resources based on cloud-native identifiers (ARNs, FQNs, GRNs) and Terraform provider/type metadata.

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

Body

Request to get recommendations for IaCM-managed cloud resources

Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendation/overview/iacm
POST /gateway/ccm/api/recommendation/overview/iacm?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 185

{
  "resources": [
    {
      "provider": "registry.terraform.io/hashicorp/aws",
      "type": "aws_instance",
      "resourceId": "arn:aws:ec2:us-east-1:123456789012:instance/i-0123456789abcdef0"
    }
  ],
  "states": [
    "OPEN"
  ]
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return the list of Recommendations

post

Returns the list of Recommendations for the specified filters.

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

Body

Properties of the CCMRecommendation Filter defined in Harness

minSavingnumber · doubleOptional

Fetch recommendations with Saving more than minSaving

minCostnumber · doubleOptional

Fetch recommendations with Cost more than minCost

daysBackinteger · int64Optional

Fetch recommendations generated in last daysBack days

offsetinteger · int64Optional

Query Offset

limitinteger · int64Optional

Query Limit

sortBystring · enumOptional

Field to sort recommendations by. Allowed values: MONTHLY_SAVING, MONTHLY_COST, APPLIED_AT, RESOURCE_TYPE

Possible values:
sortOrderstring · enumOptional

Sort order for recommendations. Allowed values: ASCENDING, DESCENDING. Defaults to DESCENDING

Possible values:
childRecommendationbooleanOptional

toggle childRecommendation value

includeIgnoredRecommendationbooleanOptional

toggle includeIgnoredRecommendation value

parentRecommendationbooleanOptional

toggle parentRecommendation value

filterTypestring · enumOptionalPossible values:
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendation/overview/list
POST /gateway/ccm/api/recommendation/overview/list?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 1947

{
  "k8sRecommendationFilterPropertiesDTO": {
    "ids": [
      "text"
    ],
    "names": [
      "text"
    ],
    "namespaces": [
      "text"
    ],
    "clusterNames": [
      "text"
    ],
    "resourceTypes": [
      "WORKLOAD"
    ],
    "recommendationStates": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "regions": [
      "text"
    ]
  },
  "awsRecommendationFilterPropertiesDTO": {
    "instanceType": [
      "text"
    ]
  },
  "azureRecommendationFilterProperties": {
    "instanceType": [
      "text"
    ],
    "resourceGroup": [
      "text"
    ]
  },
  "containerRecommendationFilterPropertiesDTO": {
    "k8sClusterName": [
      "text"
    ],
    "k8sNamespace": [
      "text"
    ],
    "ecsClusterName": [
      "text"
    ],
    "ecsLaunchType": [
      "text"
    ]
  },
  "governanceRecommendationFilterPropertiesDTO": {
    "governanceRuleName": [
      "text"
    ]
  },
  "baseRecommendationFilterPropertiesDTO": {
    "id": [
      "text"
    ],
    "cloudAccountId": [
      "text"
    ],
    "cloudAccountName": [
      "text"
    ],
    "resourceId": [
      "text"
    ],
    "resourceName": [
      "text"
    ],
    "region": [
      "text"
    ],
    "resourceType": [
      "WORKLOAD"
    ],
    "recommendationState": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "appliedAtStartTime": 1,
    "appliedAtEndTime": 1,
    "appliedByUserName": [
      "text"
    ],
    "verificationStatus": [
      "text"
    ],
    "perspectiveId": [
      "text"
    ]
  },
  "perspectiveFilters": [
    {
      "idFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "NOT_IN",
        "values": [
          "text"
        ]
      },
      "timeFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "AFTER",
        "value": 1
      },
      "timeRangeTypeFilter": "LAST_MONTH",
      "viewMetadataFilter": {
        "viewId": "text",
        "isPreview": true,
        "preview": true
      },
      "ruleFilter": {
        "conditions": [
          {
            "field": {
              "fieldId": "text",
              "fieldName": "text",
              "identifier": "CLUSTER",
              "identifierName": "text"
            },
            "operator": "NOT_IN",
            "values": [
              "text"
            ]
          }
        ]
      }
    }
  ],
  "minSaving": 1,
  "minCost": 1,
  "daysBack": 1,
  "offset": 1,
  "limit": 1,
  "sortBy": "MONTHLY_SAVING",
  "sortOrder": "ASCENDING",
  "childRecommendation": true,
  "includeIgnoredRecommendation": true,
  "parentRecommendation": true,
  "tagDTOs": [
    {
      "key": "text",
      "value": "text"
    }
  ],
  "costCategoryDTOs": [
    {
      "costCategory": "text",
      "costBucket": "text"
    }
  ],
  "tags": {
    "ANY_ADDITIONAL_PROPERTY": "text"
  },
  "filterType": "CCMRecommendation"
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return boolean

put

Override savings for recommendation

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

recommendationIdstringRequired
overriddenSavingsnumber · doubleRequired
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
put/recommendation/overview/override-savings
PUT /gateway/ccm/api/recommendation/overview/override-savings?accountIdentifier=text&recommendationId=text&overriddenSavings=1 HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Accept: */*
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return time series statistics for realized savings with date information

post

Returns the time series statistics for realized savings from applied recommendations.

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

timeAggregationstring · enumOptional

Time aggregation (daily, weekly, monthly, yearly).

Possible values:
Body

Properties of the CCMRecommendation Filter defined in Harness

minSavingnumber · doubleOptional

Fetch recommendations with Saving more than minSaving

minCostnumber · doubleOptional

Fetch recommendations with Cost more than minCost

daysBackinteger · int64Optional

Fetch recommendations generated in last daysBack days

offsetinteger · int64Optional

Query Offset

limitinteger · int64Optional

Query Limit

sortBystring · enumOptional

Field to sort recommendations by. Allowed values: MONTHLY_SAVING, MONTHLY_COST, APPLIED_AT, RESOURCE_TYPE

Possible values:
sortOrderstring · enumOptional

Sort order for recommendations. Allowed values: ASCENDING, DESCENDING. Defaults to DESCENDING

Possible values:
childRecommendationbooleanOptional

toggle childRecommendation value

includeIgnoredRecommendationbooleanOptional

toggle includeIgnoredRecommendation value

parentRecommendationbooleanOptional

toggle parentRecommendation value

filterTypestring · enumOptionalPossible values:
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendation/overview/realized-savings
POST /gateway/ccm/api/recommendation/overview/realized-savings?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 1947

{
  "k8sRecommendationFilterPropertiesDTO": {
    "ids": [
      "text"
    ],
    "names": [
      "text"
    ],
    "namespaces": [
      "text"
    ],
    "clusterNames": [
      "text"
    ],
    "resourceTypes": [
      "WORKLOAD"
    ],
    "recommendationStates": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "regions": [
      "text"
    ]
  },
  "awsRecommendationFilterPropertiesDTO": {
    "instanceType": [
      "text"
    ]
  },
  "azureRecommendationFilterProperties": {
    "instanceType": [
      "text"
    ],
    "resourceGroup": [
      "text"
    ]
  },
  "containerRecommendationFilterPropertiesDTO": {
    "k8sClusterName": [
      "text"
    ],
    "k8sNamespace": [
      "text"
    ],
    "ecsClusterName": [
      "text"
    ],
    "ecsLaunchType": [
      "text"
    ]
  },
  "governanceRecommendationFilterPropertiesDTO": {
    "governanceRuleName": [
      "text"
    ]
  },
  "baseRecommendationFilterPropertiesDTO": {
    "id": [
      "text"
    ],
    "cloudAccountId": [
      "text"
    ],
    "cloudAccountName": [
      "text"
    ],
    "resourceId": [
      "text"
    ],
    "resourceName": [
      "text"
    ],
    "region": [
      "text"
    ],
    "resourceType": [
      "WORKLOAD"
    ],
    "recommendationState": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "appliedAtStartTime": 1,
    "appliedAtEndTime": 1,
    "appliedByUserName": [
      "text"
    ],
    "verificationStatus": [
      "text"
    ],
    "perspectiveId": [
      "text"
    ]
  },
  "perspectiveFilters": [
    {
      "idFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "NOT_IN",
        "values": [
          "text"
        ]
      },
      "timeFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "AFTER",
        "value": 1
      },
      "timeRangeTypeFilter": "LAST_MONTH",
      "viewMetadataFilter": {
        "viewId": "text",
        "isPreview": true,
        "preview": true
      },
      "ruleFilter": {
        "conditions": [
          {
            "field": {
              "fieldId": "text",
              "fieldName": "text",
              "identifier": "CLUSTER",
              "identifierName": "text"
            },
            "operator": "NOT_IN",
            "values": [
              "text"
            ]
          }
        ]
      }
    }
  ],
  "minSaving": 1,
  "minCost": 1,
  "daysBack": 1,
  "offset": 1,
  "limit": 1,
  "sortBy": "MONTHLY_SAVING",
  "sortOrder": "ASCENDING",
  "childRecommendation": true,
  "includeIgnoredRecommendation": true,
  "parentRecommendation": true,
  "tagDTOs": [
    {
      "key": "text",
      "value": "text"
    }
  ],
  "costCategoryDTOs": [
    {
      "costCategory": "text",
      "costBucket": "text"
    }
  ],
  "tags": {
    "ANY_ADDITIONAL_PROPERTY": "text"
  },
  "filterType": "CCMRecommendation"
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return Recommendations statistics Grouped on Resource Type

post

Returns the Recommendations statistics for the specified filters Grouped on Resource Type.

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

Body

Properties of the CCMRecommendation Filter defined in Harness

minSavingnumber · doubleOptional

Fetch recommendations with Saving more than minSaving

minCostnumber · doubleOptional

Fetch recommendations with Cost more than minCost

daysBackinteger · int64Optional

Fetch recommendations generated in last daysBack days

offsetinteger · int64Optional

Query Offset

limitinteger · int64Optional

Query Limit

sortBystring · enumOptional

Field to sort recommendations by. Allowed values: MONTHLY_SAVING, MONTHLY_COST, APPLIED_AT, RESOURCE_TYPE

Possible values:
sortOrderstring · enumOptional

Sort order for recommendations. Allowed values: ASCENDING, DESCENDING. Defaults to DESCENDING

Possible values:
childRecommendationbooleanOptional

toggle childRecommendation value

includeIgnoredRecommendationbooleanOptional

toggle includeIgnoredRecommendation value

parentRecommendationbooleanOptional

toggle parentRecommendation value

filterTypestring · enumOptionalPossible values:
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendation/overview/resource-type/stats
POST /gateway/ccm/api/recommendation/overview/resource-type/stats?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 1947

{
  "k8sRecommendationFilterPropertiesDTO": {
    "ids": [
      "text"
    ],
    "names": [
      "text"
    ],
    "namespaces": [
      "text"
    ],
    "clusterNames": [
      "text"
    ],
    "resourceTypes": [
      "WORKLOAD"
    ],
    "recommendationStates": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "regions": [
      "text"
    ]
  },
  "awsRecommendationFilterPropertiesDTO": {
    "instanceType": [
      "text"
    ]
  },
  "azureRecommendationFilterProperties": {
    "instanceType": [
      "text"
    ],
    "resourceGroup": [
      "text"
    ]
  },
  "containerRecommendationFilterPropertiesDTO": {
    "k8sClusterName": [
      "text"
    ],
    "k8sNamespace": [
      "text"
    ],
    "ecsClusterName": [
      "text"
    ],
    "ecsLaunchType": [
      "text"
    ]
  },
  "governanceRecommendationFilterPropertiesDTO": {
    "governanceRuleName": [
      "text"
    ]
  },
  "baseRecommendationFilterPropertiesDTO": {
    "id": [
      "text"
    ],
    "cloudAccountId": [
      "text"
    ],
    "cloudAccountName": [
      "text"
    ],
    "resourceId": [
      "text"
    ],
    "resourceName": [
      "text"
    ],
    "region": [
      "text"
    ],
    "resourceType": [
      "WORKLOAD"
    ],
    "recommendationState": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "appliedAtStartTime": 1,
    "appliedAtEndTime": 1,
    "appliedByUserName": [
      "text"
    ],
    "verificationStatus": [
      "text"
    ],
    "perspectiveId": [
      "text"
    ]
  },
  "perspectiveFilters": [
    {
      "idFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "NOT_IN",
        "values": [
          "text"
        ]
      },
      "timeFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "AFTER",
        "value": 1
      },
      "timeRangeTypeFilter": "LAST_MONTH",
      "viewMetadataFilter": {
        "viewId": "text",
        "isPreview": true,
        "preview": true
      },
      "ruleFilter": {
        "conditions": [
          {
            "field": {
              "fieldId": "text",
              "fieldName": "text",
              "identifier": "CLUSTER",
              "identifierName": "text"
            },
            "operator": "NOT_IN",
            "values": [
              "text"
            ]
          }
        ]
      }
    }
  ],
  "minSaving": 1,
  "minCost": 1,
  "daysBack": 1,
  "offset": 1,
  "limit": 1,
  "sortBy": "MONTHLY_SAVING",
  "sortOrder": "ASCENDING",
  "childRecommendation": true,
  "includeIgnoredRecommendation": true,
  "parentRecommendation": true,
  "tagDTOs": [
    {
      "key": "text",
      "value": "text"
    }
  ],
  "costCategoryDTOs": [
    {
      "costCategory": "text",
      "costBucket": "text"
    }
  ],
  "tags": {
    "ANY_ADDITIONAL_PROPERTY": "text"
  },
  "filterType": "CCMRecommendation"
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return Recommendations statistics

post

Returns the Recommendations statistics for the specified filters.

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

Body

Properties of the CCMRecommendation Filter defined in Harness

minSavingnumber · doubleOptional

Fetch recommendations with Saving more than minSaving

minCostnumber · doubleOptional

Fetch recommendations with Cost more than minCost

daysBackinteger · int64Optional

Fetch recommendations generated in last daysBack days

offsetinteger · int64Optional

Query Offset

limitinteger · int64Optional

Query Limit

sortBystring · enumOptional

Field to sort recommendations by. Allowed values: MONTHLY_SAVING, MONTHLY_COST, APPLIED_AT, RESOURCE_TYPE

Possible values:
sortOrderstring · enumOptional

Sort order for recommendations. Allowed values: ASCENDING, DESCENDING. Defaults to DESCENDING

Possible values:
childRecommendationbooleanOptional

toggle childRecommendation value

includeIgnoredRecommendationbooleanOptional

toggle includeIgnoredRecommendation value

parentRecommendationbooleanOptional

toggle parentRecommendation value

filterTypestring · enumOptionalPossible values:
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendation/overview/stats
POST /gateway/ccm/api/recommendation/overview/stats?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 1947

{
  "k8sRecommendationFilterPropertiesDTO": {
    "ids": [
      "text"
    ],
    "names": [
      "text"
    ],
    "namespaces": [
      "text"
    ],
    "clusterNames": [
      "text"
    ],
    "resourceTypes": [
      "WORKLOAD"
    ],
    "recommendationStates": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "regions": [
      "text"
    ]
  },
  "awsRecommendationFilterPropertiesDTO": {
    "instanceType": [
      "text"
    ]
  },
  "azureRecommendationFilterProperties": {
    "instanceType": [
      "text"
    ],
    "resourceGroup": [
      "text"
    ]
  },
  "containerRecommendationFilterPropertiesDTO": {
    "k8sClusterName": [
      "text"
    ],
    "k8sNamespace": [
      "text"
    ],
    "ecsClusterName": [
      "text"
    ],
    "ecsLaunchType": [
      "text"
    ]
  },
  "governanceRecommendationFilterPropertiesDTO": {
    "governanceRuleName": [
      "text"
    ]
  },
  "baseRecommendationFilterPropertiesDTO": {
    "id": [
      "text"
    ],
    "cloudAccountId": [
      "text"
    ],
    "cloudAccountName": [
      "text"
    ],
    "resourceId": [
      "text"
    ],
    "resourceName": [
      "text"
    ],
    "region": [
      "text"
    ],
    "resourceType": [
      "WORKLOAD"
    ],
    "recommendationState": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "appliedAtStartTime": 1,
    "appliedAtEndTime": 1,
    "appliedByUserName": [
      "text"
    ],
    "verificationStatus": [
      "text"
    ],
    "perspectiveId": [
      "text"
    ]
  },
  "perspectiveFilters": [
    {
      "idFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "NOT_IN",
        "values": [
          "text"
        ]
      },
      "timeFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "AFTER",
        "value": 1
      },
      "timeRangeTypeFilter": "LAST_MONTH",
      "viewMetadataFilter": {
        "viewId": "text",
        "isPreview": true,
        "preview": true
      },
      "ruleFilter": {
        "conditions": [
          {
            "field": {
              "fieldId": "text",
              "fieldName": "text",
              "identifier": "CLUSTER",
              "identifierName": "text"
            },
            "operator": "NOT_IN",
            "values": [
              "text"
            ]
          }
        ]
      }
    }
  ],
  "minSaving": 1,
  "minCost": 1,
  "daysBack": 1,
  "offset": 1,
  "limit": 1,
  "sortBy": "MONTHLY_SAVING",
  "sortOrder": "ASCENDING",
  "childRecommendation": true,
  "includeIgnoredRecommendation": true,
  "parentRecommendation": true,
  "tagDTOs": [
    {
      "key": "text",
      "value": "text"
    }
  ],
  "costCategoryDTOs": [
    {
      "costCategory": "text",
      "costBucket": "text"
    }
  ],
  "tags": {
    "ANY_ADDITIONAL_PROPERTY": "text"
  },
  "filterType": "CCMRecommendation"
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Return Recommendations lifecycle & adoption statistics

post

Returns lifecycle & adoption statistics (generated, applied, inferred and ignored buckets plus conversion rate) for the recommendations matching the specified filters.

Query parameters
accountIdentifierstringRequired

Account Identifier for the Entity.

Body

Properties of the CCMRecommendation Filter defined in Harness

minSavingnumber · doubleOptional

Fetch recommendations with Saving more than minSaving

minCostnumber · doubleOptional

Fetch recommendations with Cost more than minCost

daysBackinteger · int64Optional

Fetch recommendations generated in last daysBack days

offsetinteger · int64Optional

Query Offset

limitinteger · int64Optional

Query Limit

sortBystring · enumOptional

Field to sort recommendations by. Allowed values: MONTHLY_SAVING, MONTHLY_COST, APPLIED_AT, RESOURCE_TYPE

Possible values:
sortOrderstring · enumOptional

Sort order for recommendations. Allowed values: ASCENDING, DESCENDING. Defaults to DESCENDING

Possible values:
childRecommendationbooleanOptional

toggle childRecommendation value

includeIgnoredRecommendationbooleanOptional

toggle includeIgnoredRecommendation value

parentRecommendationbooleanOptional

toggle parentRecommendation value

filterTypestring · enumOptionalPossible values:
Responses
400

Bad Request

application/json

This is Failure entity as defied in Harness

statusstring · enumOptionalPossible values:
codestring · enumOptionalPossible values:
messagestringOptional
correlationIdstringOptional
post/recommendations/v2/lifecycle-stats
POST /gateway/ccm/api/recommendations/v2/lifecycle-stats?accountIdentifier=text HTTP/1.1
Host: nextgen-ce-d788d786-ssnpc
Content-Type: application/json
Accept: */*
Content-Length: 1947

{
  "k8sRecommendationFilterPropertiesDTO": {
    "ids": [
      "text"
    ],
    "names": [
      "text"
    ],
    "namespaces": [
      "text"
    ],
    "clusterNames": [
      "text"
    ],
    "resourceTypes": [
      "WORKLOAD"
    ],
    "recommendationStates": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "regions": [
      "text"
    ]
  },
  "awsRecommendationFilterPropertiesDTO": {
    "instanceType": [
      "text"
    ]
  },
  "azureRecommendationFilterProperties": {
    "instanceType": [
      "text"
    ],
    "resourceGroup": [
      "text"
    ]
  },
  "containerRecommendationFilterPropertiesDTO": {
    "k8sClusterName": [
      "text"
    ],
    "k8sNamespace": [
      "text"
    ],
    "ecsClusterName": [
      "text"
    ],
    "ecsLaunchType": [
      "text"
    ]
  },
  "governanceRecommendationFilterPropertiesDTO": {
    "governanceRuleName": [
      "text"
    ]
  },
  "baseRecommendationFilterPropertiesDTO": {
    "id": [
      "text"
    ],
    "cloudAccountId": [
      "text"
    ],
    "cloudAccountName": [
      "text"
    ],
    "resourceId": [
      "text"
    ],
    "resourceName": [
      "text"
    ],
    "region": [
      "text"
    ],
    "resourceType": [
      "WORKLOAD"
    ],
    "recommendationState": [
      "OPEN"
    ],
    "cloudProvider": [
      "AWS"
    ],
    "appliedAtStartTime": 1,
    "appliedAtEndTime": 1,
    "appliedByUserName": [
      "text"
    ],
    "verificationStatus": [
      "text"
    ],
    "perspectiveId": [
      "text"
    ]
  },
  "perspectiveFilters": [
    {
      "idFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "NOT_IN",
        "values": [
          "text"
        ]
      },
      "timeFilter": {
        "field": {
          "fieldId": "text",
          "fieldName": "text",
          "identifier": "CLUSTER",
          "identifierName": "text"
        },
        "operator": "AFTER",
        "value": 1
      },
      "timeRangeTypeFilter": "LAST_MONTH",
      "viewMetadataFilter": {
        "viewId": "text",
        "isPreview": true,
        "preview": true
      },
      "ruleFilter": {
        "conditions": [
          {
            "field": {
              "fieldId": "text",
              "fieldName": "text",
              "identifier": "CLUSTER",
              "identifierName": "text"
            },
            "operator": "NOT_IN",
            "values": [
              "text"
            ]
          }
        ]
      }
    }
  ],
  "minSaving": 1,
  "minCost": 1,
  "daysBack": 1,
  "offset": 1,
  "limit": 1,
  "sortBy": "MONTHLY_SAVING",
  "sortOrder": "ASCENDING",
  "childRecommendation": true,
  "includeIgnoredRecommendation": true,
  "parentRecommendation": true,
  "tagDTOs": [
    {
      "key": "text",
      "value": "text"
    }
  ],
  "costCategoryDTOs": [
    {
      "costCategory": "text",
      "costBucket": "text"
    }
  ],
  "tags": {
    "ANY_ADDITIONAL_PROPERTY": "text"
  },
  "filterType": "CCMRecommendation"
}
{
  "status": "SUCCESS",
  "code": "DEFAULT_ERROR_CODE",
  "message": "text",
  "correlationId": "text",
  "errors": [
    {
      "fieldId": "text",
      "error": "text"
    }
  ]
}

Last updated

Was this helpful?